////////////////////////////////////////////////////////////////////////////////
//
// kdtree.c
//
// CS 240, Fall 2015
// Project 5
//
// Name: 
//

#include "kdtree.h"

////////////////////////////////////////////////////////////////////////////////
//  Private Helper Function Declarations
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//  kD-tree Construction and Cleanup
////////////////////////////////////////////////////////////////////////////////

void kdtree_init(kdtree_t *tree) {
    tree->root = NULL;
    tree->size = 0;
}

void kdtree_free(kdtree_t *tree) {
}

void kdtree_build(kdtree_t *tree, debris_t array[], size_t length) {
}


////////////////////////////////////////////////////////////////////////////////
//  Iterators
////////////////////////////////////////////////////////////////////////////////

kdtree_iterator_t kdtree_iterator_begin(kdtree_t *tree) {
    return tree->root;
}

kdtree_iterator_t kdtree_iterator_end(kdtree_t *tree) {
    return NULL;
}

kdtree_iterator_t kdtree_iterator_next(kdtree_iterator_t it) {

    if (it->left != NULL) return it->left;
    if (it->right != NULL) return it->right;

    kdtree_node_t *prev = it;
    kdtree_node_t *cur = it->parent;
    kdtree_node_t *ret = NULL;
    while (cur != NULL && ret == NULL) {
        if (prev == cur->left && cur->right != NULL) {
            ret = cur->right;
        } else {
            prev = cur;
            cur = cur->parent;
        }
    }

    return ret;
}

debris_t kdtree_iterator_value_at(kdtree_iterator_t it) {
    return it->debris;
}


////////////////////////////////////////////////////////////////////////////////
//  Range Searching
////////////////////////////////////////////////////////////////////////////////

void kdtree_box_range_search(kdtree_t *tree, bbox_t range, dynarray_t *debris_in_range) {
}

void kdtree_circ_range_search(kdtree_t *tree, point_t p, float radius, dynarray_t *debris_in_range) {
}


////////////////////////////////////////////////////////////////////////////////
//  Private Helper Function Definitions
////////////////////////////////////////////////////////////////////////////////

